Summary: A package for making image galleries available on the web
Name: WebMagick
Version: 2.02
Release: 1
Copyright: GPL
Group: Applications/Internet
URL: http://webmagick.sourceforge.net
Packager: Chris Lindell <clindell@users.sourceforge.net>
#BuildRoot: /var/tmp/%{name}-buildroot
Source0: WebMagick-2.02.tar.gz
Source1: WebMagick-rh70cache-2.02.tar.gz

Requires: ImageMagick >= 5.2, perl >= 5.0, Magick.so

%description
WebMagick makes image collections available on the Web. It recurses through directory 
trees, building HTML pages, imagemap files, and client-side/server-side maps or
HTML tables to allow the user to navigate through collections of thumbnail
galleries. 
 
Using JavaScript, HTML tables and cookies, WebMagick can also allow the viewer to 
configure how they view the gallery. 

The primary focus of WebMagick is performance. Image thumbnails are reduced and 
composed into a single image to reduce client accesses, reducing server load and 
improving client performance. Everything is pre-computed. During operation WebMagick 
employs innovative caching and work-avoidance techniques to make successive executions 
much faster. WebMagick has been successfully executed on directory trees containing 
many hundreds of directories and hundreds of thousands of images ranging from 
tiny icons to large JPEGs and PDF files.

%prep
%setup -T -b 0 -b 1

%build
./configure --cache-file=config.rh70.cache

%install
make install 
#nahhh maybe we should do this manually. It's just copying files
# but do we need to include docs? Probably not
# need to install that webmagickrc

%clean
#rm -rf $RPM_BUILD_ROOT

%files
/var/www/html/images/webmagick/aqua_next.gif
/var/www/html/images/webmagick/aqua_prev.gif
/var/www/html/images/webmagick/blue_ball.gif
/var/www/html/images/webmagick/blue_ball_large.gif
/var/www/html/images/webmagick/blue_ball_medium.gif
/var/www/html/images/webmagick/blue_c.gif
/var/www/html/images/webmagick/blue_dir.gif
/var/www/html/images/webmagick/blue_down.gif
/var/www/html/images/webmagick/blue_help.gif
/var/www/html/images/webmagick/blue_next.gif
/var/www/html/images/webmagick/blue_prev.gif
/var/www/html/images/webmagick/blue_readme.gif
/var/www/html/images/webmagick/blue_top.gif
/var/www/html/images/webmagick/blue_up.gif
/var/www/html/images/webmagick/gray_next.gif
/var/www/html/images/webmagick/gray_prev.gif
/var/www/html/images/webmagick/frame-style-1.jpg
/var/www/html/images/webmagick/frame-style-2.jpg
/var/www/html/images/webmagick/frame-style-3.jpg
/var/www/html/images/webmagick/frame-style-4.jpg
/var/www/html/images/webmagick/webmagick.js
/var/www/html/images/webmagick/blank.html
/usr/local/bin/webmagick
%config /usr/local/etc/webmagickrc
%doc /usr/local/info/webmagick.info
%doc /usr/local/info/webmagick.info-1
%doc /usr/local/info/webmagick.info-2
%doc /usr/local/info/webmagick.info-3
%doc /usr/local/man/man1/webmagick.1
%doc doc/webmagick.html
%doc doc/fig
%doc README NEWS TODO ChangeLog AUTHORS COPYING webmagick.lsm

%changelog
* Thu Aug 9 2001 Chris Lindell <clindell@users.sourceforge.net>

- New PerlMagick (from ImageMagick 5.3.6) rename 
   Get() attributes:base_rows -> base-rows
   base_columns -> base-columns
- New PerlMagick does strange things for colorspace 
   'YUV', colors 256 options for writting GIF montages 
   - whole picture fade in background. Better way is 
   just remove this options - they are not neccessary 
   for writing GIFs, all handled automatically.
- 'Prev' arrow for very first page is not useful if 
   README is not present since it just reload the 
   same frameset. I convert it to 'Up' arrow
   in that particular case.
- blue_c.gif now correctly included in distribution
- compatible with Win32 ActiveState Perl


* Fri Jul 27 2001 Chris Lindell <clindell@users.sourceforge.net>

- Version 2.0
- added $opt_allowconfig for user configuration
- added $opt_tables for using HTML tables
  instead of montages. Much faster processing
  and navigation
- solve incompatibilities with NS6
- added version check for status file
- can now handle rc and status files over 100k
- handle new ImageMagick Ping return value
- smaller .index.js files for faster downloads


* Wed May 23 2001 Chris Lindell <clindell@users.sourceforge.net>

- disabled lockfile due to bug
- correctly install webmagickrc

* Tue May 22 2001 Chris Lindell <clindell@users.sourceforge.net> 
- first rpm


